'use strict'; // eslint-disable-line strict

var BigNumber = require('bignumber.js');

var _require = require('./utils'),
    dropsToZxc = _require.dropsToZxc;

function parseFeeUpdate(tx) {
  var baseFeeDrops = new BigNumber(tx.BaseFee, 16).toString();
  return {
    baseFeeZXC: dropsToZxc(baseFeeDrops),
    referenceFeeUnits: tx.ReferenceFeeUnits,
    reserveBaseZXC: dropsToZxc(tx.ReserveBase),
    reserveIncrementZXC: dropsToZxc(tx.ReserveIncrement)
  };
}

module.exports = parseFeeUpdate;