'use strict'; // eslint-disable-line strict

var common = require('../common');
var keypairs = require('chainsql-keypairs');
var binary = require('chainsql-binary-codec');
var validate = common.validate,
    zxcToDrops = common.zxcToDrops;


function signPaymentChannelClaim(channel, amount, privateKey) {
  validate.signPaymentChannelClaim({ channel: channel, amount: amount, privateKey: privateKey });

  var signingData = binary.encodeForSigningClaim({
    channel: channel,
    amount: zxcToDrops(amount)
  });
  return keypairs.sign(signingData, privateKey);
}

module.exports = signPaymentChannelClaim;